#############################################################################
## Various process-related utilities.
##
## --------------------------------------------------------------------------
## Copyright (C) 2008 The Regents of the University of California.
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
## $Id: processutils.rb,v 1.4 2008/07/11 00:41:48 youngh Exp $
#############################################################################

module ArkUtil

  # Based on perlipc(1).
  def self.daemonize
    Dir.chdir "/"
    STDIN.reopen "/dev/null", "r"
    STDOUT.reopen "/dev/null", "w"
    STDERR.reopen STDOUT
    $stdin = STDIN
    $stdout = STDOUT
    $stderr = STDERR
    fork && exit(0)
    Process.setsid
  end

end  # module ArkUtil
